searchNodes=[{"doc":"FLHook is a community-managed tool for managing Freelancer game servers. Freelancer is a pretty old game that has been released in 2003 by Microsoft, but it still has a very committed community. FLHook allows connecting via a socket to run commands on and receive events from a Freelancer Server. This library provides an Elixir client for that matter. You could use it to build web-based management interfaces or ingame chat bots, for example. Connect to Server { :ok , client } = FLHook.Client . start_link ( host : &quot;myserver.com&quot; , password : &quot;s3cret&quot; , ) Alternatively, create your own module that you can configure in your application. defmodule MyFLClient do use FLHook.Client end Add the client to your supervision tree: defmodule MyApp.Application do use Application def start ( _type , _args ) do Supervisor . start_link ( [ MyFLClient ] , strategy : :one_for_one , name : MyApp.Supervisor ) end end In your config: import Config config :my_app , MyFLClient , host : &quot;localhost&quot; , port : 1920 , event_mode : true , connect_on_start : true , backoff_interval : 1000 , connect_timeout : 5000 , password : &quot;s3cret&quot; , recv_timeout : 5000 , send_timeout : 5000 Dispatch Command Send a command to the server and receive the result immediately: { :ok , result } = FLHook . cmd ( client , { &quot;addcash&quot; , [ &quot;MyUsername&quot; , 10 ] } ) new_cash = FLHook.Result . param! ( result , &quot;cash&quot; ) IO . puts ( &quot;New cash: \#{ new_cash } credits&quot; ) Listen to Events Let the current process receive FLHook events: FLHook . subscribe ( client ) receive do % FLHook.Event { type : &quot;kill&quot; , dict : dict } -&gt; IO . inspect ( dict , label : &quot;player killed&quot; ) end","ref":"FLHook.html","title":"FLHook","type":"module"},{"doc":"Sends a command to the socket and returns the result.","ref":"FLHook.html#cmd/2","title":"FLHook.cmd/2","type":"function"},{"doc":"Sends a command to the socket and returns the result. Raises on error.","ref":"FLHook.html#cmd!/2","title":"FLHook.cmd!/2","type":"function"},{"doc":"Registers the specified process as event listener.","ref":"FLHook.html#subscribe/2","title":"FLHook.subscribe/2","type":"function"},{"doc":"Removes the event listener for the specified process.","ref":"FLHook.html#unsubscribe/2","title":"FLHook.unsubscribe/2","type":"function"},{"doc":"A client to connect to a FLHook socket.","ref":"FLHook.Client.html","title":"FLHook.Client","type":"module"},{"doc":"The child specification for a FLHook client.","ref":"FLHook.Client.html#child_spec/1","title":"FLHook.Client.child_spec/1","type":"function"},{"doc":"Closes the connection.","ref":"FLHook.Client.html#close/1","title":"FLHook.Client.close/1","type":"function"},{"doc":"Indicates whether the socket is connected.","ref":"FLHook.Client.html#connected?/1","title":"FLHook.Client.connected?/1","type":"function"},{"doc":"Opens the connection.","ref":"FLHook.Client.html#open/1","title":"FLHook.Client.open/1","type":"function"},{"doc":"Starts the FLHook client using the given config or options.","ref":"FLHook.Client.html#start_link/1","title":"FLHook.Client.start_link/1","type":"function"},{"doc":"Starts the FLHook client using the given config and options.","ref":"FLHook.Client.html#start_link/2","title":"FLHook.Client.start_link/2","type":"function"},{"doc":"Type representing a FLHook client process.","ref":"FLHook.Client.html#t:client/0","title":"FLHook.Client.client/0","type":"type"},{"doc":"A struct containing configuration for a client.","ref":"FLHook.Config.html","title":"FLHook.Config","type":"module"},{"doc":"","ref":"FLHook.Config.html#t:t/0","title":"FLHook.Config.t/0","type":"type"},{"doc":"A protocol to implement custom commands.","ref":"FLHook.Command.html","title":"FLHook.Command","type":"protocol"},{"doc":"Returns a command string or tuple. It may even return another command except itself.","ref":"FLHook.Command.html#to_cmd/1","title":"FLHook.Command.to_cmd/1","type":"function"},{"doc":"Type representing a command.","ref":"FLHook.Command.html#t:command/0","title":"FLHook.Command.command/0","type":"type"},{"doc":"","ref":"FLHook.Command.html#t:serializable/0","title":"FLHook.Command.serializable/0","type":"type"},{"doc":"","ref":"FLHook.Command.html#t:t/0","title":"FLHook.Command.t/0","type":"type"},{"doc":"A module that provides helpers to decode command response and event data.","ref":"FLHook.Dict.html","title":"FLHook.Dict","type":"module"},{"doc":"Fetches the field using the specified key from the dict. Optionally allows specification of a type to coerce the param to.","ref":"FLHook.Dict.html#fetch/3","title":"FLHook.Dict.fetch/3","type":"function"},{"doc":"Fetches the field using the specified key from the dict. Optionally allows specification of a type to coerce the value to. Raises when the param is missing or could not be coerced to the given type.","ref":"FLHook.Dict.html#fetch!/3","title":"FLHook.Dict.fetch!/3","type":"function"},{"doc":"Gets the field using the specified key from the dict.","ref":"FLHook.Dict.html#get/4","title":"FLHook.Dict.get/4","type":"function"},{"doc":"Fetches multiple fields with the specified keys from the dict. Optionally allows specification of a type to coerce the param to.","ref":"FLHook.Dict.html#pick/2","title":"FLHook.Dict.pick/2","type":"function"},{"doc":"Puts multiple fields using the specified keys from the dict into the given struct. Optionally allows specification of a type to coerce the param to.","ref":"FLHook.Dict.html#pick_into/3","title":"FLHook.Dict.pick_into/3","type":"function"},{"doc":"Converts the dict to a plain map.","ref":"FLHook.Dict.html#to_map/2","title":"FLHook.Dict.to_map/2","type":"function"},{"doc":"","ref":"FLHook.Dict.html#t:data/0","title":"FLHook.Dict.data/0","type":"type"},{"doc":"","ref":"FLHook.Dict.html#t:field_type/0","title":"FLHook.Dict.field_type/0","type":"type"},{"doc":"","ref":"FLHook.Dict.html#t:key/0","title":"FLHook.Dict.key/0","type":"type"},{"doc":"","ref":"FLHook.Dict.html#t:t/0","title":"FLHook.Dict.t/0","type":"type"},{"doc":"A struct that represents a duration.","ref":"FLHook.Duration.html","title":"FLHook.Duration","type":"module"},{"doc":"","ref":"FLHook.Duration.html#t:t/0","title":"FLHook.Duration.t/0","type":"type"},{"doc":"An event that is sent by the client in event mode when something happens on the server.","ref":"FLHook.Event.html","title":"FLHook.Event","type":"module"},{"doc":"","ref":"FLHook.Event.html#t:t/0","title":"FLHook.Event.t/0","type":"type"},{"doc":"A behaviour that can be implemented by custom field types.","ref":"FLHook.FieldType.html","title":"FLHook.FieldType","type":"behaviour"},{"doc":"","ref":"FLHook.FieldType.html#c:parse/1","title":"FLHook.FieldType.parse/1","type":"callback"},{"doc":"A struct that contains result data and provides helpers to decode the contained data.","ref":"FLHook.Result.html","title":"FLHook.Result","type":"module"},{"doc":"Converts a multiline result to a list of dictionaries.","ref":"FLHook.Result.html#all/1","title":"FLHook.Result.all/1","type":"function"},{"doc":"Converts the result to a file string. Raises when the result is no file.","ref":"FLHook.Result.html#file!/1","title":"FLHook.Result.file!/1","type":"function"},{"doc":"Converts the result to a file stream. Raises when the result is no file.","ref":"FLHook.Result.html#file_stream!/1","title":"FLHook.Result.file_stream!/1","type":"function"},{"doc":"Converts a result to dictionary. When the result has multiple lines only the first one is being returned. When first line is no valid dictionary, an empty dictionary is returned.","ref":"FLHook.Result.html#one/1","title":"FLHook.Result.one/1","type":"function"},{"doc":"Converts the result to a string.","ref":"FLHook.Result.html#to_string/1","title":"FLHook.Result.to_string/1","type":"function"},{"doc":"","ref":"FLHook.Result.html#t:t/0","title":"FLHook.Result.t/0","type":"type"},{"doc":"A module that is responsible for decoding and encoding data streams from and to the FLHook socket.","ref":"FLHook.Codec.html","title":"FLHook.Codec","type":"module"},{"doc":"Decodes binary data from the socket using the specified codec.","ref":"FLHook.Codec.html#decode/2","title":"FLHook.Codec.decode/2","type":"function"},{"doc":"Encodes strings that will be sent to the socket using the specified codec.","ref":"FLHook.Codec.html#encode/2","title":"FLHook.Codec.encode/2","type":"function"},{"doc":"Type describing the supported codecs.","ref":"FLHook.Codec.html#t:codec/0","title":"FLHook.Codec.codec/0","type":"type"},{"doc":"The XML text module allows composing formatted text to be sent via a chat command.","ref":"FLHook.XMLText.html","title":"FLHook.XMLText","type":"module"},{"doc":"Adds a format node the specified XML text struct. You can specify a color and optional format flags.","ref":"FLHook.XMLText.html#format/3","title":"FLHook.XMLText.format/3","type":"function"},{"doc":"Creates a new XML text struct with the specified content.","ref":"FLHook.XMLText.html#new/1","title":"FLHook.XMLText.new/1","type":"function"},{"doc":"Adds a text node to the specified XML text struct.","ref":"FLHook.XMLText.html#text/2","title":"FLHook.XMLText.text/2","type":"function"},{"doc":"Converts the XML text struct to a string.","ref":"FLHook.XMLText.html#to_string/1","title":"FLHook.XMLText.to_string/1","type":"function"},{"doc":"","ref":"FLHook.XMLText.html#t:color/0","title":"FLHook.XMLText.color/0","type":"type"},{"doc":"","ref":"FLHook.XMLText.html#t:flag/0","title":"FLHook.XMLText.flag/0","type":"type"},{"doc":"","ref":"FLHook.XMLText.html#t:t/0","title":"FLHook.XMLText.t/0","type":"type"},{"doc":"An error indicating that decoding or encoding did not work.","ref":"FLHook.CodecError.html","title":"FLHook.CodecError","type":"exception"},{"doc":"","ref":"FLHook.CodecError.html#t:t/0","title":"FLHook.CodecError.t/0","type":"type"},{"doc":"An error indicating a command returned unsuccessfully.","ref":"FLHook.CommandError.html","title":"FLHook.CommandError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"FLHook.CommandError.html#message/1","title":"FLHook.CommandError.message/1","type":"function"},{"doc":"","ref":"FLHook.CommandError.html#t:t/0","title":"FLHook.CommandError.t/0","type":"type"},{"doc":"An error that indicates that configuration of the client is invalid.","ref":"FLHook.ConfigError.html","title":"FLHook.ConfigError","type":"exception"},{"doc":"An error indicating an invalid or missing param.","ref":"FLHook.FieldError.html","title":"FLHook.FieldError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"FLHook.FieldError.html#message/1","title":"FLHook.FieldError.message/1","type":"function"},{"doc":"","ref":"FLHook.FieldError.html#t:t/0","title":"FLHook.FieldError.t/0","type":"type"},{"doc":"An error that indicates that the socket connection is not a valid FLHook socket or the encoding is wrong.","ref":"FLHook.HandshakeError.html","title":"FLHook.HandshakeError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"FLHook.HandshakeError.html#message/1","title":"FLHook.HandshakeError.message/1","type":"function"},{"doc":"An error that indicates that the socket connection has a problem.","ref":"FLHook.SocketError.html","title":"FLHook.SocketError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"FLHook.SocketError.html#message/1","title":"FLHook.SocketError.message/1","type":"function"},{"doc":"","ref":"FLHook.SocketError.html#t:t/0","title":"FLHook.SocketError.t/0","type":"type"},{"doc":"MIT License Copyright (c) 2020 Tobias Casper Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"FLHook is a community-managed tool for managing Freelancer game servers. Freelancer is a pretty old game that has been released in 2003 by Microsoft, but it still has a very committed community. FLHook allows connecting via a socket to run commands on and receive events from a Freelancer Server. This library provides an Elixir client for that matter. You could use it to build web-based management interfaces or ingame chat bots, for example.","ref":"readme.html","title":"Readme","type":"extras"},{"doc":"Chat Bots Web-based Services Character Management Character Money Deposit Character Cargo Deposit Player Tracking and Travel Journal Custom Cargo Missions","ref":"readme.html#use-cases","title":"Readme - Use Cases","type":"extras"},{"doc":"The package is available in Hex and can be installed by adding fl_hook_client to your list of dependencies in mix.exs : def deps do [ { :fl_hook_client , &quot;~&gt; 2.0&quot; } ] end","ref":"readme.html#installation","title":"Readme - Installation","type":"extras"},{"doc":"Initiate a connection to a server (with a list of all possible options): { :ok , client } = FLHook.Client . start_link ( backoff_interval : 1234 , codec : :unicode , connect_timeout : 2345 , event_mode : true , host : &quot;localhost&quot; , inet_adapter : :inet , name : CustomFLHookClient , password : &quot;$3cret&quot; , port : 1920 , recv_timeout : 3456 , send_timeout : 4567 , tcp_adapter : :gen_tcp ) Once connected, you can send commands to the server. FLHook . cmd ( client , &quot;readcharfile Player1&quot; ) # =&gt; {:ok, %FLHook.Result{lines: [&quot;...&quot;, &quot;...&quot;]}} Alternatively, you can use the tuple format for commands: FLHook . cmd ( client , { &quot;readcharfile&quot; , [ &quot;Player1&quot; ] } ) Additionally, any value is accepted as command argument that implements the FLHook.Command protocol. By default, also events from the server will be sent to all subscribed processes. You can add a listener for the current process as follows: FLHook . subscribe ( client ) You can also register other processes as listeners: pid = self ( ) Task . async ( fn -&gt; FLHook . subscribe ( client , pid ) end ) Unsubscription works the same way. The received events have the following format: iex&gt; flush ( ) % FLHook.Event { type : &quot;launch&quot; , dict : % FLHook.Dict { data : &quot;system&quot; =&gt; &quot;Li01&quot; , &quot;char&quot; =&gt; &quot;Player&quot; } } Generally, it is recommended to start the client as part of your supervision tree. To do this, add a custom module using the FLHook.Client module. defmodule MyApp.FLClient do use FLHook.Client , otp_app : :my_app end Then, add some configuration in config.exs or your environment-specific configs. config :my_app , MyApp.FLClient , host : &quot;localhost&quot; , port : 1920 After that, add your custom client to your application.ex. def start ( _type , _args ) do children = [ MyApp.FLClient ] # ... end Voilà! You can now send commands to the same server without passing the client process as first argument. MyApp.FLClient . cmd ( client , &quot;readcharfile Player1&quot; ) # =&gt; {:ok, %FLHook.Result{lines: [&quot;...&quot;, &quot;...&quot;]}}","ref":"readme.html#usage","title":"Readme - Usage","type":"extras"},{"doc":"Documentation can be generated with ExDoc and is published on HexDocs .","ref":"readme.html#docs","title":"Readme - Docs","type":"extras"}]